/*
 * ToGrammarLeftRG.h
 *
 *  Created on: 9. 2. 2014
 *      Author: Tomas Pecka
 */

#ifndef __TO_GRAMMAR_LEFT_RG_H__
#define __TO_GRAMMAR_LEFT_RG_H__

#include <grammar/Regular/LeftRG.h>
#include <automaton/FSM/NFA.h>
#include <automaton/FSM/DFA.h>

namespace automaton {

namespace convert {

/**
 * Finite automaton to right regular grammar converter.
 * Source: My own :)
 */
class ToGrammarLeftRG {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static grammar::LeftRG < > convert(const automaton::NFA < > & automaton);
	static grammar::LeftRG < > convert(const automaton::DFA<>& automaton);
};

} /* namespace convert */

} /* namespace automaton */

#endif /* __TO_GRAMMAR_LEFT_RG_H__ */
