/*
 * Occurrences.cpp
 *
 *  Created on: 9. 2. 2014
 *	  Author: Jan Travnicek
 */

#include "Occurrences.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace run {

auto OccurrencesDFALinearString = registration::AbstractRegister < Occurrences, ext::set < unsigned >, const automaton::DFA < > &, const string::LinearString < > & > ( Occurrences::occurrences );
auto OccurrencesDFTARankedTree = registration::AbstractRegister < Occurrences, ext::set < unsigned >, const automaton::DFTA < > &, const tree::RankedTree < > & > ( Occurrences::occurrences );
auto OccurrencesInputDrivenDPDALinearString = registration::AbstractRegister < Occurrences, ext::set < unsigned >, const automaton::InputDrivenDPDA < > &, const string::LinearString < > & > ( Occurrences::occurrences );
auto OccurrencesVisiblyPushdownDPDALinearString = registration::AbstractRegister < Occurrences, ext::set < unsigned >, const automaton::VisiblyPushdownDPDA < > &, const string::LinearString < > & > ( Occurrences::occurrences );
auto OccurrencesRealTimeHeightDeterministicDPDALinearString = registration::AbstractRegister < Occurrences, ext::set < unsigned >, const automaton::RealTimeHeightDeterministicDPDA < > &, const string::LinearString < > & > ( Occurrences::occurrences );
auto OccurrencesDPDALinearString = registration::AbstractRegister < Occurrences, ext::set < unsigned >, const automaton::DPDA < > &, const string::LinearString < > & > ( Occurrences::occurrences );

} /* namespace run */

} /* namespace automaton */
