/*
 * ToGrammarRightRGGlushkov.h
 *
 *  Created on: 11. 1. 2014
 *	  Author: Tomas Pecka
 */

#ifndef TO_GRAMMAR_RIGHT_RG_GLUSHKOV_H_
#define TO_GRAMMAR_RIGHT_RG_GLUSHKOV_H_

#include <grammar/Regular/RightRG.h>
#include <regexp/formal/FormalRegExp.h>
#include <regexp/unbounded/UnboundedRegExp.h>

namespace regexp {

namespace convert {

/**
 * Converts regular expression to right regular grammar using Glushkov algorithm.
 * Source: None yet.
 */
class ToGrammarRightRGGlushkov {
public:
	/**
	 * Performs conversion.
	 * @param regexp original regular expression
	 * @return right regular grammar equivalent to source regexp.
	 */
	static grammar::RightRG < > convert(const regexp::FormalRegExp < > & regexp);
	static grammar::RightRG < > convert(const regexp::UnboundedRegExp < > & regexp);
};

} /* namespace convert */

} /* namespace regexp */

#endif /* TO_GRAMMAR_RIGHT_RG_GLUSHKOV_H_ */
