#ifndef HOPCROFT_TEST_H_
#define HOPCROFT_TEST_H_

#include <cppunit/extensions/HelperMacros.h>

class GraphHopcroftTest : public CppUnit::TestFixture
{
	CPPUNIT_TEST_SUITE(GraphHopcroftTest);
	/* !!todo!!   fix  graph::isomorphism::hopcroft::Graph::init
	CPPUNIT_TEST(testCircleIsomorphism);
	CPPUNIT_TEST(testEmbedding);
	CPPUNIT_TEST(testEdges);
	CPPUNIT_TEST(testRemoveEdge);
	CPPUNIT_TEST(testAddInnerEdge);
	CPPUNIT_TEST(testRemoveDistinguishedEdge);
	CPPUNIT_TEST(testRemoveFourDegreeExceptionEdge);
	CPPUNIT_TEST(testAddAndReconnectVertexIntoTriangularFace);
	CPPUNIT_TEST(testIsomorphismByDefinition);
	CPPUNIT_TEST(testReductionsSameGraphs);
	CPPUNIT_TEST(testReductionsIsomorphicGraphs);
	CPPUNIT_TEST(testReductionsOther);
	*/
	CPPUNIT_TEST_SUITE_END();

public:
	void testCircleIsomorphism();
	void testEmbedding();
	void testEdges();
	void testRemoveEdge();
	void testAddInnerEdge();
	void testRemoveDistinguishedEdge();
	void testRemoveFourDegreeExceptionEdge();
	void testAddAndReconnectVertexIntoTriangularFace();
	void testIsomorphismByDefinition();
	void testReductionsSameGraphs();
	void testReductionsIsomorphicGraphs();
	void testReductionsOther();
};

#endif // HOPCROFT_TEST_H_
