#ifndef _CLI_PARAM_H_
#define _CLI_PARAM_H_

#include <ast/Ast.h>
#include <abstraction/OperationAbstraction.hpp>
#include <environment/Environment.h>

namespace cli {

class Param {
	bool m_move;

public:
	Param ( bool move ) : m_move ( move ) {
	}

	virtual ~Param ( ) noexcept {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > & prev, Environment & environment ) const = 0;

	bool getMove ( ) const {
		return m_move;
	}
};

} /* namespace cli */

#endif /* _CLI_PARAM_H_ */
