/*
 * Automaton.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef AUTOMATON_H_
#define AUTOMATON_H_

#include <base/WrapperBase.hpp>
#include "AutomatonBase.h"

namespace automaton {

/**
 * Wrapper around automata.
 */
class Automaton : public base::WrapperBase < AutomatonBase > {
	using base::WrapperBase < AutomatonBase >::WrapperBase;

};

template < class T >
using SymbolTypeOfAutomaton = typename std::decay < decltype (std::declval<T>().getInputAlphabet()) >::type::value_type;

template < class T >
using StateTypeOfAutomaton = typename std::decay < decltype (std::declval<T>().getStates()) >::type::value_type;

} /* namespace automaton */

#endif /* AUTOMATON_H_ */
