/*
 * NFA.cpp
 *
 *  Created on: Mar 25, 2013
 *      Author: Jan Travnicek
 */

#include "NFA.h"
#include <automaton/Automaton.h>
#include <object/Object.h>

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>
#include <registration/CastRegistration.hpp>

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < automaton::NFA < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < automaton::NFA < > > ( );
static auto xmlRead = registration::XmlReaderRegister < automaton::NFA < > > ( );

static auto xmlGroup1 = registration::XmlRegisterTypeInGroup < automaton::Automaton, automaton::NFA < > > ( );
static auto xmlGroup2 = registration::XmlRegisterTypeInGroup < object::Object, automaton::NFA < > > ( );

static auto NFAFromDFA = registration::CastRegister < automaton::NFA < >, automaton::DFA < > > ( );

} /* namespace */
