/*
 * CFG.cpp
 *
 *  Created on: Nov 17, 2013
 *      Author: Jan Travnicek
 */

#include "CFG.h"
#include <grammar/Grammar.h>
#include <object/Object.h>

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>
#include <registration/CastRegistration.hpp>

namespace {

static auto CFGEpsilonFreeCFG = registration::CastRegister < grammar::CFG < >, grammar::EpsilonFreeCFG < > > ( );

static auto valuePrinter = registration::ValuePrinterRegister < grammar::CFG < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < grammar::CFG < > > ( );
static auto xmlRead = registration::XmlReaderRegister < grammar::CFG < > > ( );

static auto xmlGroup1 = registration::XmlRegisterTypeInGroup < grammar::Grammar, grammar::CFG < > > ( );
static auto xmlGroup2 = registration::XmlRegisterTypeInGroup < object::Object, grammar::CFG < > > ( );

} /* namespace */
