/*
 * RegExp.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef REG_EXP_H_
#define REG_EXP_H_

#include <base/WrapperBase.hpp>
#include "RegExpBase.h"

#include <common/DefaultSymbolType.h>
#include <string/StringFeatures.h>
#include <alib/string>
#include <alib/vector>

namespace regexp {

/**
 * Wrapper around automata.
 */
class RegExp : public base::WrapperBase < RegExpBase > {
	using base::WrapperBase < RegExpBase >::WrapperBase;

};

regexp::RegExp regexpFrom ( const std::string & string );

regexp::RegExp regexpFrom ( const char * string );

regexp::RegExp regexpFrom ( string::LinearString < > string );

regexp::RegExp regexpFrom ( ext::vector < DefaultSymbolType > string );

regexp::RegExp regexpFrom ( DefaultSymbolType symbol );

regexp::RegExp regexpFrom ( );

} /* namespace regexp */

#endif /* REG_EXP_H_ */
