/*
 * String.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_H_
#define STRING_H_

#include <base/WrapperBase.hpp>
#include "StringBase.h"
#include <alib/set>
#include <alib/vector>
#include <common/DefaultSymbolType.h>

namespace string {

/**
 * Wrapper around strings.
 */
class String : public base::WrapperBase < StringBase > {
	using base::WrapperBase < StringBase >::WrapperBase;

};

string::String stringFrom ( const DefaultSymbolType & symbol );
string::String stringFrom ( const std::string & str );
string::String stringFrom ( const char * str );
string::String stringFrom ( const ext::vector < DefaultSymbolType > & str );

} /* namespace string */

#endif /* STRING_H_ */
