/*
 * TreeBase.h
 *
 *  Created on: Nov 16, 2014
 *      Author: Stepan Plachy
 */

#ifndef TREE_BASE_H_
#define TREE_BASE_H_

#include <object/ObjectBase.h>

#include <core/xmlApi.hpp>

namespace tree {

/**
 * Represents symbol in an alphabet.
 */
class TreeBase : public object::ObjectBase {
public:
	virtual TreeBase* clone() const = 0;
	virtual TreeBase* plunder() && = 0;
};

} /* namespace tree */

namespace core {

template < typename Type >
struct xmlApi < Type, typename std::enable_if < std::is_base_of < tree::TreeBase, Type >::value >::type > {
	static Type parse ( ext::deque < sax::Token >::iterator & input ) {
		return Type::parse ( input );
	}

	static bool first ( const ext::deque < sax::Token >::const_iterator & input ) {
		return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName() );
	}

	static std::string xmlTagName ( ) {
		return Type::getXmlTagName();
	}

	static void compose ( ext::deque < sax::Token > & output, const Type & data ) {
		Type::compose ( output, data );
	}

};

} /* namespace core */

#endif /* TREE_BASE_H_ */
