/*
 * RawReaderRegistry.cpp
 *
 *  Created on: 21. 8. 2017
 *	  Author: Jan Travnicek
 */

#include <registry/RawReaderRegistry.hpp>
#include <alib/algorithm>
#include <alib/typeinfo>

namespace abstraction {

std::shared_ptr < abstraction::OperationAbstraction > RawReaderRegistry::getAbstraction ( const std::string & type ) {
	for ( const std::pair < const std::string, std::unique_ptr < Entry > > & entry : getEntries ( ) ) {
		std::string entryType = ext::erase_template_info ( entry.first );
		if ( entryType == type )
			return entry.second->getAbstraction ( );
	}

	throw exception::CommonException ( "Entry " + type + " not available." );

}

} /* namespace abstraction */
