/*
 * clone.hpp
 *
 * Created on: Apr 1, 2013
 * Author: Jan Travnicek
 */

#ifndef __CLONE_HPP_
#define __CLONE_HPP_

#include "type_traits.hpp"

namespace ext {

template<class T, typename std::enable_if< ! ext::has_clone<T>::value >::type* = nullptr>
T* clone(const T * const tmp) {
	return new T(*tmp);
}

template<class T, typename std::enable_if< ext::has_clone<T>::value >::type* = nullptr>
T* clone(const T * const tmp) {
	return tmp->clone();
}

} /* namespace ext */

#endif /* __CLONE_HPP_ */
