/*
 * functional.hpp
 *
 * Created on: Apr 1, 2013
 * Author: Jan Travnicek
 */

#ifndef _FUNCTIONAL_HPP_
#define _FUNCTIONAL_HPP_

#include <functional>

namespace ext {

template < class T >
class reference_wrapper : public std::reference_wrapper < T > {
public:
#ifdef __clang__
	using std::reference_wrapper < T >::reference_wrapper;
	using std::reference_wrapper < T >::operator =;
#else
	reference_wrapper ( ) noexcept : std::reference_wrapper < T > ( ) {
	}

	reference_wrapper ( const reference_wrapper & other ) = default;

	reference_wrapper ( reference_wrapper && other ) = default;

	using std::reference_wrapper < T >::reference_wrapper;

	reference_wrapper & operator = ( reference_wrapper && other ) = default;

	reference_wrapper & operator = ( const reference_wrapper & other ) = default;

	using std::reference_wrapper < T >::operator =;
#endif
	using std::reference_wrapper < T >::operator T &;
};

} /* namespace ext */

#endif /* _FUNCTIONAL_HPP_ */
