/*
 * ObjectLabel.cpp
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#include "ObjectLabel.h"
#include <label/ObjectLabel.h>
#include <primitive/string/String.h>
#include <object/Object.h>
#include <label/Label.h>

#include <registration/StringRegistration.hpp>

namespace core {

label::ObjectLabel stringApi < label::ObjectLabel >::parse ( std::istream & ) {
	throw exception::CommonException("parsing ObjectLabel from string not implemented");
}

bool stringApi < label::ObjectLabel >::first ( std::istream & ) {
	return false;
}

void stringApi < label::ObjectLabel >::compose ( std::ostream & output, const label::ObjectLabel & label ) {
	stringApi < object::Object >::compose ( output, label.getData ( ) );
}

} /* namespace core */

namespace {

static auto stringWrite = registration::StringWriterRegister < label::Label, label::ObjectLabel > ( );
static auto stringWrite2 = registration::StringWriterRegister < object::Object, label::ObjectLabel > ( );

} /* namespace */
