/*
 * PrimitiveLabel.cpp
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#include "PrimitiveLabel.h"
#include <label/PrimitiveLabel.h>
#include <object/Object.h>
#include <label/Label.h>

#include <registration/StringRegistration.hpp>

namespace core {

label::PrimitiveLabel stringApi < label::PrimitiveLabel >::parse ( std::istream & input ) {
	return label::PrimitiveLabel ( stringApi < primitive::Primitive >::parse ( input ) );
}

bool stringApi < label::PrimitiveLabel >::first ( std::istream & input ) {
	return stringApi < primitive::Primitive >::first ( input );
}

void stringApi < label::PrimitiveLabel >::compose ( std::ostream & output, const label::PrimitiveLabel & label ) {
	stringApi < primitive::Primitive >::compose ( output, label.getData ( ) );
}

} /* namespace core */

namespace {

static auto stringWrite = registration::StringWriterRegister < label::Label, label::PrimitiveLabel > ( );
static auto stringWrite2 = registration::StringWriterRegister < object::Object, label::PrimitiveLabel > ( );

static auto stringRead = registration::StringReaderRegister < label::Label, label::PrimitiveLabel > ( );

} /* namespace */
