/*
 * Unsigned.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "Unsigned.h"
#include <primitive/Primitive.h>
#include <object/Object.h>

#include <registration/XmlRegistration.hpp>

namespace core {

unsigned xmlApi < unsigned >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
	unsigned data = ext::from_string < unsigned > ( sax::FromXMLParserHelper::popTokenData ( input, sax::Token::TokenType::CHARACTER ) );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );
	return data;
}

bool xmlApi < unsigned >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < unsigned >::xmlTagName ( ) {
	static std::string xmlTagName = "Unsigned";

	return xmlTagName;
}

void xmlApi < unsigned >::compose ( ext::deque < sax::Token > & output, unsigned data ) {
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT );
	output.emplace_back ( ext::to_string ( data ), sax::Token::TokenType::CHARACTER );
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT );
}

primitive::Unsigned xmlApi < primitive::Unsigned >::parse ( ext::deque < sax::Token >::iterator & input ) {
	return primitive::Unsigned ( xmlApi < unsigned >::parse ( input ) );
}

bool xmlApi < primitive::Unsigned >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < primitive::Unsigned >::xmlTagName ( ) {
	return xmlApi < unsigned >::xmlTagName ( );
}

void xmlApi < primitive::Unsigned >::compose ( ext::deque < sax::Token > & output, const primitive::Unsigned & data ) {
	xmlApi < unsigned >::compose ( output, data.getData ( ) );
}

} /* namespace core */

namespace {

static auto xmlWrite = registration::XmlWriterRegister < primitive::Unsigned > ( );
static auto xmlRead = registration::XmlReaderRegister < primitive::Unsigned > ( );

static auto xmlGroup1 = registration::XmlRegisterTypeInGroup < primitive::Primitive, primitive::Unsigned > ( );
static auto xmlGroup2 = registration::XmlRegisterTypeInGroup < object::Object, primitive::Unsigned > ( );

} /* namespace */
